# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
import urllib
from threading import Thread
from gi.repository import GObject
import time
import logging
logger = logging.getLogger('dockremoteclient')
class LibraryLoader(Thread):
	def __init__(self, url, sup):
        if url[:7] == "http://":
            urlstart = 7
        elif url[:1] == "/":
            urlstart = 1
        else:
            urlstart = 0
        url = url[urlstart:]
        if url[-2:] == "//":
            endurl = -2
        elif url[-1:] == "/":
            endurl = -1
        else:
            endurl = len(url)
        url = url[:endurl]
		self.url = "http://" + url + "/"
        self.progressbar = sup.bar
        self.label = sup.progresslabel
        self.tracklist = sup.tlist
        self.update = sup.update_table
        Thread.__init__(self)

    def run(self):
        tot = self.count_songs()
        ava = 0
        artists = self.get_artists()
        self.stopped = 0
        self.paused = 0
        n = 0
        for (artist_name, aid) in artists:
            n = n + 1
            if 1:
                try:
                    albums = self.get_albums_from_artist(aid)
                    for (album_name, alid) in albums:
                        try:
                            songs = self.get_songs_from_artist_and_album(aid, alid)
                            for (song_name, sid) in songs:
                                try:
                                    track = {}
                                    track["title"] = song_name
                                    track["album"] = album_name
                                    track["artist"] = artist_name
                                    track["sid"] = sid
                                    track["aid"] = aid
                                    track["alid"] = alid
                                    self.tracklist.append([song_name, artist_name, album_name, sid, aid, alid])
                                    GObject.idle_add(self.progressbar.set_fraction, float(ava)/tot)
                                    GObject.idle_add(self.progressbar.set_text, str(ava))
                                    ava = ava + 1
                                    if self.stopped:
                                        return
                                    elif self.paused:
                                        logger.debug("Paused")
                                        while self.paused:
                                            if self.stopped:
                                                return
                                            time.sleep(1)
                                except Exception as e:
                                    logger.error("Error :", e.__str__())
                        except Exception as e:
                            logger.error("Error :", e.__str__())
                except Exception as e:
                    logger.error("Error :", e.__str__())
                GObject.idle_add(self.label.set_text, artist_name)
        GObject.idle_add(self.update)

    def stop(self):
        self.stopped = 1

    def get_url(self, url):
        try:
		    stuff = urllib.urlopen(url).read();
        except Exception as e:
            logger.error("Error :", e.__str__())
        else:
            return stuff
        

    def pause(self):
        self.paused = 1

    def resume(self):
        self.paused = 0
                    
	def count_songs(self):
		url = self.url + "songs"
		stuff = self.get_url(url)
        return len(stuff.split('{"title":'))
                  
	def get_artists(self):
		url = self.url + "artists"
		stuff = self.get_url(url)
		artists = self.parse(stuff, "aid")
        return artists

	def get_albums_from_artist(self, aid):
		url = self.url + "albumsForArtist?aid=" + aid
		stuff = self.get_url(url)
        stuff = stuff[stuff.find('","albums":[{"title":') + len('","albums":[{"title":'):]
		albums = self.parse(stuff, "alid", "title", "}\n,\n{")
        return albums

	def get_songs_from_artist_and_album(self, aid, alid):
		url = self.url + "songsForArtistAndAlbum?aid=" + aid + "&alid=" + alid
		stuff = self.get_url(url)
        stuff = stuff[stuff.find('","songs":[{"title":') + len('","songs":[{"title":'):]
		songs = self.parse(stuff, "sid", "title", "}\n,\n{")
        return songs

	def parse(self, stuff, idn, name="name", separator="},\n{"):
		if stuff[0:1] == "[":
			stuff = stuff[1:]
		if stuff[0:1] == "\n":
			stuff = stuff[1:]
		if stuff[0:1] == "{":
			stuff = stuff[1:]
		if stuff[0:7] == "\"" + name + "\":":
			stuff = stuff[7:]
		if stuff[-1:] == "\n":
			stuff = stuff[:-1]
		if stuff[-1:] == "}":
			stuff = stuff[:-1]
		if stuff[-1:] == "]":
			stuff = stuff[:-1]
		if stuff[-1:] == "\n":
			stuff = stuff[:-1]
		if stuff[-1:] == "}":
			stuff = stuff[:-1]
		obj = stuff.split(separator + "\"" + name + "\":")
        objects = []
        for i in obj:
            if i[0:1] == "\"":
                i = i[1:]
            if i[-1:] == "\"":
                i = i[:-1]
            name = i[0:i.find('","' + idn + '":"')]
            id = i[i.find('","' + idn + '":"') + 6 + len(idn):]
            objects.append((name, id))
        return objects
		
