import logging
import dbus
from dbus.mainloop.glib import DBusGMainLoop

 
class MediaKeyHandler(object):
    def __init__(self, remote):
        self.app = "dockremoteclient"
	dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)
        self.bus = dbus.Bus(dbus.Bus.TYPE_SESSION)
        self.bus_object = self.bus.get_object(
            'org.gnome.SettingsDaemon', '/org/gnome/SettingsDaemon/MediaKeys')
 
        self.bus_object.GrabMediaPlayerKeys(
            self.app, 0, dbus_interface='org.gnome.SettingsDaemon.MediaKeys')
 
        self.bus_object.connect_to_signal(
            'MediaPlayerKeyPressed', self.handle_mediakey)
	self.remote = remote
 
    def handle_mediakey(self, application, *mmkeys):
        if application != self.app:
            return
        for key in mmkeys:
            if key in ('Play', 'PlayPause', 'Pause'):
                self.remote.toggle_play()
            elif key == "Stop":
                self.remote.pause()
            elif key == "Next":
                self.remote.next()
            elif key == "Previous":
                self.remote.prev()
 
def get_media_key_handler(window, remote):
    """
    Creates and returns a MediaKeyHandler or returns None if such a thing
    is not available on this platform.
 
    :param window: a Gtk.Window instance
    """
    try:
        return MediaKeyHandler(window, remote)
    except dbus.DBusException:
        logging.exception("cannot load MediaKeyHandler")
