# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
import sqlite3, os, os.path

class MusicData():
	def __init__(self, path):
		self.path = path
		self.conn = False
		self.c = False

	def connect(self):
        if not os.path.isdir(os.path.split(self.path)[0]):
            os.mkdir(os.path.split(self.path)[0])
		try:
			self.conn = sqlite3.connect(self.path, check_same_thread = False)
            self.conn.text_factory = str
			self.c = self.conn.cursor()
		except Exception as e:
            print "Error :", e
			return False
        self.c.execute('SELECT name FROM sqlite_master WHERE type = "table"')
        if len(self.c.fetchall()) == 0:
            self.c.execute('create table library (title text, artist text, album text, sid text, aid text, alid text)')
            self.c.execute('create table queue (title text, artist text, album text, sid text, aid text, alid text)')
            return 2
        return 1
        

	def fill_library(self, data):
        self.c.execute('DELETE FROM library WHERE 1')
        for i in data:
            self.c.execute('INSERT INTO library VALUES(?, ?, ?, ?, ?, ?)', i)
        self.conn.commit()

    def get_library(self):
        self.c.execute('SELECT * FROM library')
        return self.c.fetchall()

    def fill_queue(self, data):
        self.c.execute('DELETE FROM queue WHERE 1')
        for i in data:
            self.c.execute('INSERT INTO queue VALUES(?, ?, ?, ?, ?, ?)', i)
        self.conn.commit()

    def remove_from_queue(self, song):
        self.c.execute('DELETE FROM queue WHERE sid=?', [song])
        self.conn.commit()

    def remove_from_library(self, song):
        self.c.execute('DELETE FROM library WHERE sid=?', [song])
        self.conn.commit()

    def add_to_queue(self, song):
        self.c.execute('INSERT INTO queue VALUES(?, ?, ?, ?, ?, ?)', song)
        self.conn.commit()

    def get_queue(self):
        self.c.execute('SELECT * FROM queue')
        return self.c.fetchall()
