from gi.repository import Notify
from gi.repository import GdkPixbuf
from threading import Thread
from gi.repository import Gdk
import time
import gettext
from gettext import gettext as _
gettext.textdomain('dockremoteclient')

class DockRemoteClientNotifyOsd():

	def __init__(self, remote, settings):
		self.initialized = 0
		self.settings = settings
		self.remote = remote
		self.coverpixbuf = None
		if settings.settings.get_boolean("enable-notifications"):
			self.init()
			

	def init(self):
		self.initialized = 1
		Notify.init('RemoteDock')
		self.downloading = 0
		self.notify = Notify.Notification.new('Test', 'Test notification', 'dialog-information')
		self.last_title = ""
		self.last_artist = ""
		self.last_album = ""
		self.nexticon	  = 'notification-audio-next'
		self.previcon	  = 'notification-audio-previous'
		self.pauseicon	  = 'notification-audio-pause'
		self.playicon	 = 'notification-audio-play'
		self.stopicon	   = 'notification-audio-stop'

	class CoverDownloader(Thread):
		def __init__(self, finished, remote):
			self.finished = finished
			self.remote = remote
			Thread.__init__(self)

		def run(self):
			media_icon = self.remote.get_cover()
			pixbuf = None
			if media_icon:
				try:
					loader = GdkPixbuf.PixbufLoader()
					loader.write(media_icon)
					loader.close()
					loader.set_size(128, 128)
					pixbuf = loader.get_pixbuf()
				except Exception as e:
		    			print "Error :", e
			self.finished(pixbuf)
	class ShowNotification(Thread):
		def __init__(self, show):
			self.show = show
			Thread.__init__(self)

		def run(self):
			self.show()



	def on_quit(self):
		self.notify.close()


	def update_notify(self, action):
		if self.settings.settings.get_boolean("enable-notifications") and self.initialized == 0:
			self.init()
		if self.settings.settings.get_boolean("enable-notifications") and self.initialized:
			title = self.remote.info["title"]
			album = self.remote.info["album"]
			artist = self.remote.info["artist"]
			if title == "":
				self.summary = "Nessuna canzone in riproduzione"
				self.body = ""
				self.cover = self.stopicon

				self.notify.update(self.summary, self.body, self.cover)
				s = self.ShowNotification(self.notify.show)
				s.start()
			else:
				self.summary = title
				if action == "play":
					self.cover = self.playicon
					self.summary = title + _(" (playing)")
				elif action == "pause":
					self.cover = self.pauseicon
					self.summary = title + _(" (paused)")
				elif action == "next":
					self.cover = self.nexticon
				elif action == "prev":
					self.cover = self.previcon
				else: self.cover = None



				if artist and album:
					self.body = artist + " - " + album
				elif artist:
					self.body = artist
				elif album:
					self.body = album
				else:
					self.body = ""
				self.notify.update(self.summary, self.body, self.cover)
				if self.last_title == title and self.last_album == album and self.last_artist == artist and self.coverpixbuf != None:
					s = self.ShowNotification(self.notify.show)
					s.start()
					return
				s = self.ShowNotification(self.notify.show)
				s.start()
				self.last_title = title
				self.last_album = album
				self.last_artist = artist
				if self.settings.settings.get_boolean("album-cover-notifications") and self.downloading == 0:
					self.downloading = 1
					c = self.CoverDownloader(self.finished, self.remote)
					c.start()
				
	def finished(self, pixbuf):
		self.coverpixbuf = pixbuf
		self.notify.update(self.summary, self.body, self.cover)
		self.notify.set_icon_from_pixbuf(self.coverpixbuf)
		self.notify.show()
		self.downloading = 0

