# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# This file is in the public domain
### END LICENSE

# This is your preferences dialog.
#
# Define your preferences in
# data/glib-2.0/schemas/net.launchpad.dockremoteclient.gschema.xml
# See http://developer.gnome.org/gio/stable/GSettings.html for more info.

from gi.repository import Gio # pylint: disable=E0611

import gettext
from gettext import gettext as _
gettext.textdomain('dockremoteclient')

import logging
logger = logging.getLogger('dockremoteclient')

from dockremoteclient_lib.PreferencesDialog import PreferencesDialog

class PreferencesDockRemoteClientDialog(PreferencesDialog):
    __gtype_name__ = "PreferencesDockRemoteClientDialog"

    def finish_initializing(self, builder): # pylint: disable=E1002
        """Set up the preferences dialog"""
        super(PreferencesDockRemoteClientDialog, self).finish_initializing(builder)

        # Bind each preference widget to gsettings
        self.settings = Gio.Settings("net.launchpad.dockremoteclient")
        
        self.ipaddressentry = self.builder.get_object('ipaddressentry')
        self.settings.bind("ip-address", self.ipaddressentry, "text", Gio.SettingsBindFlags.DEFAULT)
        self.maximizedswitch = self.builder.get_object('maximizedswitch')
        self.settings.bind("maximized", self.maximizedswitch, "active", Gio.SettingsBindFlags.DEFAULT)
        self.mediakeyswitch = self.builder.get_object('mediakeyswitch')
        self.settings.bind("media-keys", self.mediakeyswitch, "active", Gio.SettingsBindFlags.DEFAULT)
        self.notificationsswitch = self.builder.get_object('notificationsswitch')
        self.settings.bind("enable-notifications", self.notificationsswitch, "active", Gio.SettingsBindFlags.DEFAULT)
        self.albumcoverswitch = self.builder.get_object('albumcoverswitch')
        self.settings.bind("album-cover-notifications", self.albumcoverswitch, "active", Gio.SettingsBindFlags.DEFAULT)
        self.albumcoversswitch = self.builder.get_object('albumcoversswitch')
        self.settings.bind("album-covers", self.albumcoversswitch, "active", Gio.SettingsBindFlags.DEFAULT)
        self.usmcoversswitch = self.builder.get_object('usmcoversswitch')
        self.settings.bind("mpris-album-covers", self.usmcoversswitch, "active", Gio.SettingsBindFlags.DEFAULT)

        # Code for other initialization actions should be added here.
