# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
from gi.repository import Gio
class Settings():
	def __init__(self, update_function):
        self.settings = Gio.Settings("net.launchpad.dockremoteclient")
        self.update_function = update_function
	
	def get(self, k):
		if k in ["ip-address", "db-path"]:
            return self.settings.get_string(k)
        elif k in ["maximized", "media-keys", "enable-notifications", "album-cover-notifications", "show-queue", "album-covers", "mpris-album-covers"]:
            return self.settings.get_boolean(k)
        elif k in ["repeat-mode", "shuffle-mode"]:
            return self.settings.get_int(k)
        else:
            print "Unknown option \"" + k + "\""

	def set(self, k, v):
		self.settings.set_string(k, v)

    def connect_widget(self, widget, key, type="text"):
        self.settings.bind(key, widget, type, Gio.SettingsBindFlags.DEFAULT)

    def activate(self):
        self.settings.connect('changed', self.update_function)
