# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# This file is in the public domain
### END LICENSE

from gi.repository import Gtk # pylint: disable=E0611
from gi.repository import GLib

from dockremoteclient_lib.helpers import get_builder
from dockremoteclient.LibraryLoader import LibraryLoader
import gettext
from gettext import gettext as _
gettext.textdomain('dockremoteclient')
class SyncprogressDialog(Gtk.Dialog):
    __gtype_name__ = "SyncprogressDialog"
    def __new__(cls):
        """Special static method that's automatically called by Python when 
        constructing a new instance of this class.
        
        Returns a fully instantiated SyncprogressDialog object.
        """
        builder = get_builder('SyncprogressDialog')
        new_object = builder.get_object('syncprogressdialog')
        new_object.finish_initializing(builder)
        return new_object

    def finish_initializing(self, builder):
        """Called when we're finished initializing.

        finish_initalizing should be called after parsing the ui definition
        and creating a SyncprogressDialog object with it in order to
        finish initializing the start of the new SyncprogressDialog
        instance.
        """
        # Get a reference to the builder and set up the signals.
        self.builder = builder
        self.ui = builder.get_ui(self)
        self.pausebutton = self.builder.get_object('pausebutton')
        self.bar = self.builder.get_object('progressbar')
        self.progresslabel = self.builder.get_object('progressinfo')
        self.tlist = []
        GLib.threads_init()

    def give_parent(self, parent):
            self.parent = parent

    def on_pausebutton_clicked(self, widget, data=None):
        if self.paused:
            self.loader.resume()
            self.pausebutton.set_label(Gtk.STOCK_MEDIA_PAUSE)
            self.paused = 0
        else:
            self.loader.pause()
            self.pausebutton.set_label(Gtk.STOCK_REDO)
            self.paused = 1

    def update_table(self):
        self.active = 0
        self.parent.library.populate(self.tlist)
        self.close_dialog()

    def synclibrary(self):
        self.active = 1
        self.pausebutton.set_label(Gtk.STOCK_MEDIA_PAUSE)
        self.loader = LibraryLoader(self.parent.settings.get("ip-address"), self)
        self.loader.start()

    def reset(self):
        self.active = 0
        self.paused = 0
        self.bar.set_fraction(float(0))
        self.progresslabel.set_text("")
        self.tlist = []

    def close_dialog(self):
        self.hide()

    def start(self):
        self.synclibrary()
        
    def on_cancelbutton_clicked(self, widget, data=None):
        if self.active:
            self.loader.stop()
        self.close_dialog()
