# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-

from threading import Thread
from gi.repository import GObject
import time

class Timer(Thread):
	def __init__(self, update_progressbar, ask_update, handle_next_song):
		Thread.__init__(self)
		self.active = 1
		self.update_progressbar = update_progressbar
		self.ask_update = ask_update
		self.handle_next_song = handle_next_song
		self.duration = 1
		self.playing = 0
        self.pause_all = 1
		self.time_end = time.time() + 1

	def run(self):
        self.cicle = 0
		while self.active:
            if not self.pause_all:
			    if self.playing and self.duration != 0:
				    value = (self.duration - self.time_end + time.time())/self.duration
				    GObject.idle_add(self.update_progressbar, value, int(self.duration) - int((self.time_end - time.time())), int(self.duration))
				    if (self.time_end - time.time() < 5 and self.time_end - time.time() >= 4.8) or (self.time_end - time.time() >= 5 and self.cicle > 24):
					    self.ask_update(True)
                        self.cicle = 0
				    elif self.time_end - time.time() <= 0.4 and self.time_end - time.time() > 0.2:
					    self.handle_next_song()
				    elif self.time_end - time.time() <= 0:
					    self.ask_update(True)
					    time.sleep(1)
                elif self.cicle > 24:
                    self.ask_update(True)
                    self.cicle = 0
                self.cicle += 1
			time.sleep(0.2)
				
	def stop(self):
		self.active = 0;
		time.sleep(0.2)

	def play(self):
		self.playing = 1
        self.pause_all = 0

	def pause(self, all=False):
		self.playing = 0
        if all:
            self.pause_all = 1

	def update(self, fraction, utime, duration, state):
        if state == "playing":
            self.play()
		self.duration = float(duration)
        self.time_updated = utime
		self.time_end = float(utime) + self.duration * (1 - float(fraction))
		GObject.idle_add(self.update_progressbar, fraction, int(self.duration) - int(self.duration * (1 - float(fraction))), int(self.duration))

