# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# This file is in the public domain
### END LICENSE

import optparse
from gi.repository import Gio, GObject
import gettext
from gettext import gettext as _
gettext.textdomain('dockremoteclient')

from gi.repository import Gtk # pylint: disable=E0611

from dockremoteclient import DockRemoteClientWindow

from dockremoteclient_lib import set_up_logging, get_version

def parse_options():
    """Support for command line options"""
    parser = optparse.OptionParser(version="%%prog %s" % get_version())
    parser.add_option(
        "-v", "--verbose", action="count", dest="verbose",
        help=_("Show debug messages (-vv debugs dockremoteclient_lib also)"))
    (options, args) = parser.parse_args()

    set_up_logging(options)

def main():
    'constructor for your class instances'
    parse_options()

	GObject.threads_init()
    # Run the application.    
    window = DockRemoteClientWindow.DockRemoteClientWindow()
    if not window.stopped_loading:
        settings = Gio.Settings("net.launchpad.dockremoteclient")
        if settings.get_boolean("maximized"):
            window.maximize()
        window.show()
        Gtk.main()
