#!/usr/bin/env python
# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
import urllib
import re
import htmlentitydefs
# Lyrics search engine for http://www.metrolyrics.com/
searcher_title = "metrolyrics.com"
searcher_url = "http://www.metrolyrics.com/"

def get_lyrics(title, artist, list_bad=False):
    url = "http://www.metrolyrics.com/search.php?category=ArtistTitle&search=" + urllib.quote(title + " " + artist)

    data = urllib.urlopen(url).read()

    if data.find('<li class="message">We did not find anything for \'') != -1:
        return [False, url]

    data = data[data.find('<ul id="search-results" class="search-artisttitle">' + "\r\n") + len('<ul id="search-results" class="search-artisttitle">' + "\r\n"):]
    data = data[:data.find("\t\t</ul>")]

    results = data.split("</li><li")
    good_result = 0
    parsed_results = []
    for i in results:
        if i[:len(' id="view-more-bar">')] == ' id="view-more-bar">':
            continue
        artistf = i[i.find('<span class="title">') + len('<span class="title">'):i.find("<br />", i.find('<span class="title">'))].replace("&#39;", "'")
        name = convert_html_entities(i[i.find("<strong>") + len("<strong>"):i.find("</strong>")])
        link = i[i.find('<a href="/') + len('<a href="/'):i.find('">\r\n\t\t', i.find('<a href="/'))]
        if name[-len(" Lyrics"):] == " Lyrics":
            name = name[:-len(" Lyrics")]
            parsed_results.append([artistf + " - " + name, "http://www.metrolyrics.com/" + link])
            if artistf.lower() == artist.lower() and name.lower() == title.lower():
                good_result = 1
                break;
    if not good_result:
        if list_bad:
            return [parsed_results, url]

    url = "http://www.metrolyrics.com/" + link
    return [get_lyrics_from_url(url), url]

def get_lyrics_from_url(url):
    data = urllib.urlopen(url).read()
    init_string = "<span class='line line-s' id='line_"
    end_string = '<br /><br /><link itemprop="name" content='
    html = data[data.find(init_string):data.find(end_string)]
    rows = html.split("<span class='line line-s' id='line_")
    lyrics = ""
    for i in rows:
        if i.find("<em") != -1:
            i = i[i.find(">", i.find("<em")):i.find("</em") + 1]
        text = convert_html_entities(i[i.find("'>") + 2:i.find("</span>")])
        lyrics += text + "\n"
    while lyrics.find("<span") != -1:
        lyrics = lyrics[:lyrics.find("<span")] + lyrics[lyrics.find(">", lyrics.find("<span")) + 1:].replace("</span>", "")
    while lyrics.find("[ From: ") != -1:
        lyrics = lyrics[:lyrics.find("[ From: ")] + lyrics[lyrics.find("html ]", lyrics.find("[ From: ")) + 6:]
    return lyrics.replace("\xec", "ì").replace("\xe8", "è").decode('utf-8', 'replace').encode('utf-8').replace("&#8217;", "'")

def convert_html_entities(s):
    matches = re.findall("&#\d+;", s)
    if len(matches) > 0:
        hits = set(matches)
        for hit in hits:
            name = hit[2:-1]
            try:
                entnum = int(name)
                s = s.replace(hit, chr(entnum))
            except ValueError:
                pass

    matches = re.findall("&#[xX][0-9a-fA-F]+;", s)
    if len(matches) > 0:
        hits = set(matches)
        for hit in hits:
            hex = hit[3:-1]
            try:
                entnum = int(hex, 16)
                s = s.replace(hit, chr(entnum))
            except ValueError:
                pass

    matches = re.findall("&\w+;", s)
    hits = set(matches)
    amp = "&amp;"
    if amp in hits:
        hits.remove(amp)
    for hit in hits:
        name = hit[1:-1]
        if htmlentitydefs.name2codepoint.has_key(name):
            s = s.replace(hit, unichr(htmlentitydefs.name2codepoint[name]))
    s = s.replace(amp, "&")
    return s
