#!/usr/bin/env python
# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
import urllib
import htmlentitydefs
import re

# Lyrics search engine for http://www.sing365.com/
searcher_title = "sing365.com"
searcher_url = "http://www.sing365.com/"

def get_lyrics(title, artist, list_bad=False):
    url = "http://seek.sing365.com/search.php?kw=on&q=" + urllib.quote(title + " " + artist) + "&submit=go"

    data = urllib.urlopen(url).read()

    if data.find("<ol start=\"1\">") == -1:
        return [False, url]

    data = data[data.find("<ol start=\"1\"><li>") + len("<ol start=\"1\"><li>"):data.find("</li></ol>")]

    results = data.split("</li><li>")
    good_result = 0
    parsed_results = []
    for i in results:
        name = i[i.find("<strong>") + len("<strong>"):i.find("</strong>")]
        link = i[len("<a href=\""):i.find("\"", len("<a href=\""))]
        if name.find(" - ") != -1 and len(link) and i.find("Release date: ") == -1:
            parsed_results.append([name, "http://seek.sing365.com/" + link])
            if name.lower() == artist.lower() + " - " + title.lower():
                good_result = 1
                break;
    if not good_result:
        if list_bad:
            return [parsed_results, url]

    url = "http://seek.sing365.com/" + link
    return [get_lyrics_from_url(url), url]

def get_lyrics_from_url(url):
    data = urllib.urlopen(url).read()
    init_string = ['<div class="fb-like" data-send="false" data-layout="box_count" data-width="60" data-show-faces="true" style="display:block;float:left"></div>']
    end_string = ['<div class=unit><script type="text/javascript">', '<script type="text/javascript">']
    for i in init_string:
        if data.find(i) != -1:
            init_string = i
            break
    end = 100000000
    for i in end_string:
        f = data.find(i, data.find(init_string))
        if f < end:
            end_string = i
            end = f
    html = data[data.find(init_string) + len(init_string):data.find(end_string, data.find(init_string))]
    lyrics = html.replace("<br>", "").replace("<BR>", "")
    while lyrics.find("<!--") != -1:
        lyrics = lyrics[:lyrics.find("<!--")] + lyrics[lyrics.find("-->", lyrics.find("<!--")) + 3:]
    if lyrics[:1] == "\n":
        lyrics = lyrics[1:]
    return convert_html_entities(lyrics)

def convert_html_entities(s):
    matches = re.findall("&#\d+;", s)
    if len(matches) > 0:
        hits = set(matches)
        for hit in hits:
            name = hit[2:-1]
            try:
                entnum = int(name)
                s = s.replace(hit, chr(entnum))
            except ValueError:
                pass

    matches = re.findall("&#[xX][0-9a-fA-F]+;", s)
    if len(matches) > 0:
        hits = set(matches)
        for hit in hits:
            hex = hit[3:-1]
            try:
                entnum = int(hex, 16)
                s = s.replace(hit, chr(entnum))
            except ValueError:
                pass

    matches = re.findall("&\w+;", s)
    hits = set(matches)
    amp = "&amp;"
    if amp in hits:
        hits.remove(amp)
    for hit in hits:
        name = hit[1:-1]
        if htmlentitydefs.name2codepoint.has_key(name):
            try:
                s = s.replace(hit, unichr(htmlentitydefs.name2codepoint[name]))
            except Exception as e:
                print e
    s = s.replace(amp, "&")
    return s
