#!/usr/bin/env python
# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# This file is in the public domain
### END LICENSE

###################### DO NOT TOUCH THIS (HEAD TO THE SECOND PART) ######################

import os
import sys

try:
    import DistUtilsExtra.auto
except ImportError:
    print >> sys.stderr, 'To build dockremoteclient you need https://launchpad.net/python-distutils-extra'
    sys.exit(1)
assert DistUtilsExtra.auto.__version__ >= '2.18', 'needs DistUtilsExtra.auto >= 2.18'

def update_config(values = {}):

    oldvalues = {}
    try:
        fin = file('dockremoteclient_lib/dockremoteclientconfig.py', 'r')
        fout = file(fin.name + '.new', 'w')

        for line in fin:
            fields = line.split(' = ') # Separate variable from value
            if fields[0] in values:
                oldvalues[fields[0]] = fields[1].strip()
                line = "%s = %s\n" % (fields[0], values[fields[0]])
            fout.write(line)

        fout.flush()
        fout.close()
        fin.close()
        os.rename(fout.name, fin.name)
    except (OSError, IOError), e:
        print ("ERROR: Can't find dockremoteclient_lib/dockremoteclientconfig.py")
        sys.exit(1)
    return oldvalues


def update_desktop_file(datadir):

    try:
        fin = file('dockremoteclient.desktop.in', 'r')
        fout = file(fin.name + '.new', 'w')

        for line in fin:            
            if 'Icon=' in line:
                line = "Icon=%s\n" % (datadir + 'media/icon.png')
            fout.write(line)
        fout.flush()
        fout.close()
        fin.close()
        os.rename(fout.name, fin.name)
    except (OSError, IOError), e:
        print ("ERROR: Can't find dockremoteclient.desktop.in")
        sys.exit(1)


class InstallAndUpdateDataDirectory(DistUtilsExtra.auto.install_auto):
    def run(self):
        values = {'__dockremoteclient_data_directory__': "'%s'" % (self.prefix + '/share/dockremoteclient/'),
                  '__version__': "'%s'" % self.distribution.get_version()}
        previous_values = update_config(values)
        update_desktop_file(self.prefix + '/share/dockremoteclient/')
        DistUtilsExtra.auto.install_auto.run(self)
        update_config(previous_values)


        
##################################################################################
###################### YOU SHOULD MODIFY ONLY WHAT IS BELOW ######################
##################################################################################

DistUtilsExtra.auto.setup(
    name='dockremoteclient',
    version='1.0.1',
    license='GPL-3',
    author='Alessandro Blarco',
    author_email='alessandro.blarco@gmail.com',
    description='GUI to control iDevice music playback (requires app)',
    long_description='Control your iPhone or iPod Touch music playback from your Ubuntu pc ' \
                'using a simple and comfortable interface (requires a compatible App). ' \
                'Download "Revererse Remote" from the Apple App Store, install Dock ' \
                'Remote Client on your Ubuntu laptop, connect your devices to the same ' \
                'network and that\'s done! You can now play, pause, select a song, use a' \
                ' smart playing queue, adjust the volume and much more!',
    url='https://launchpad.net/dockremoteclient',
    cmdclass={'install': InstallAndUpdateDataDirectory}
    )


